public class Z28_22 {
	private static double[][] diagonal(double[][] x) {
		if (x.length != x[0].length)
		    throw new ArithmeticException("To nie jest macierz kwadratowa");
		int n = x.length;    
	    double[][] tmp = new double[n][n];
	    for(int i = 0; i < n; ++i)
	        for(int j = 0; j < n; ++j)
	            tmp[i][j] = x[i][j];  
	    for(int i = 0; i < n; ++i)     
	        for(int j = 0; j < n; ++j)  {
		        if (tmp[i][i] != 0.0) {
			        if (j != i) {
		                double p = tmp[j][i]/tmp[i][i];
		                for(int k = 0; k < n; ++k)
	                        tmp[j][k] -= tmp[i][k]*p;
                    }
		        } else {
			        for(int k = i+1; k < n; ++k) {
			            if (tmp[k][i] != 0.0) {
				            for(int m = 0; m < n; ++m) {
					            double p = tmp[i][m];
					            tmp[i][m] = tmp[k][m];
					            tmp[k][m] = -p;
				            }
				            break;
			            }    				        
		            }
                }
            }    
	    return tmp;
    }
    	
    public static void main(String[] args) {
	    double[][] a = new double[6][6];
	    TDouble.setRandom(a, 10.0); 
	    System.out.println("Macierz A");
	    TDouble.printf("%8.2f", a);
	    double[][] b = diagonal(a);
	    System.out.println("Macierz B");
	    TDouble.printf("%8.2f", b);
	    double w = 1.0;
	    for(int i = 0; i < 6; ++i)
	        w *= b[i][i];
	    System.out.printf("Wyznacznik det B = %6.2f\n", w);    
    }
}